const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const chat_memberships = sequelize.define(
    'chat_memberships',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

member_role: {
        type: DataTypes.ENUM,
      
      

        values: [

"OWNER",


"MODERATOR",


"MEMBER"

        ],

      },

joined_at: {
        type: DataTypes.DATE,
      
      

      },

left_at: {
        type: DataTypes.DATE,
      
      

      },

muted: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  chat_memberships.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity





























//end loop



    db.chat_memberships.belongsTo(db.chat_rooms, {
      as: 'chat_room',
      foreignKey: {
        name: 'chat_roomId',
      },
      constraints: false,
    });

    db.chat_memberships.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });




    db.chat_memberships.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.chat_memberships.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return chat_memberships;
};


